{% extends "customers/base.html" %}
{% load i18n %}
{% load staticfiles %}
{% load active_tag %}
{% load md2 %}

{% block title %}Reportes registro de llamadas{% endblock %}

{% block pagelevelcss %}
<link href="{% static 'theme/plugins/c3/c3.min.css' %}" rel="stylesheet" type="text/css">
{% endblock %}

{% block breadcrumbs %}
  {{ block.super }}
  <li><a href="{% url 'plan-report' %}">Reportes registro de llamadas</a></li>
{% endblock breadcrumbs %}

{% block page %}
	<!-- begin page-header -->
	<h1 class="page-header">Llamadas <small>Ver llamadas por motivo</small></h1>
	<!-- end page-header -->


  

   
    <div id="service-status-app">
		<!-- begin row -->
		<div class="row">
			<!-- begin col-12 -->
			<div class="col-xl-12 ui-sortable">
				<!-- begin panel -->
				<div class="panel panel-inverse" data-sortable-id="ui-general-1">
					<!-- begin panel-heading -->
					<div class="panel-heading ui-sortable-handle">
						<h4 class="panel-title">Reporte de Llamadas</h4>
						<div class="panel-heading-btn">
							<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
							<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
							<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
							<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
						</div>
					</div>
					<!-- end panel-heading -->
					<!-- begin panel-body -->
					<div class="panel-body">
						<div class="row mb-3">
							<div class="col-sm-12 col-md-6">
								<h5 class="text-muted">Filtros:</h5>
								<p>
									<label>Desde:</label>
									<input type="date" v-model="initiald">
								</p>
							
								<p>
									<label>Hasta:</label>
									<input type="date" v-model="finald">
								</p>

								<p>
									<label>Agente:</label>
									<v-select v-model="selectedAgent" :options="agentOptions"></v-select>
								</p>
							</div>
						
					
							<div class="col-sm-12 col-md-6">
								{% verbatim %}
									<h4>Datos de llamadas</h4>
									<h5 class="text-muted">{{ message }}</h5>
									<table class="table table-bordered">
										<tr v-for="(item, key, index) in snapshots">
											<td>{{ key }}</td>
											<td>{{ item }}</td>
										</tr>
									</table>
								{% endverbatim %}
							</div>
						</div>
					</div>
					<!-- end panel-body -->
				</div>
				<!-- end panel -->
			</div>
			<!-- end col -->
		</div>
		<!-- end row -->
	</div> 
	<!-- service-status-app -->


{% endblock %}

{% block pageleveljs %}
<script type="text/javascript">
    //active menu
    document.getElementById("reports_menu").classList.add("active");
    //active submenu item
    document.getElementById("callsreport_item").classList.add("active");
</script>

<script src="{% static 'js/vue' %}"></script>
    <script src="{% static 'js/vue-resource' %}"></script>
    <script src="{% static 'js/vue-select' %}"></script>
    <script src="{% static 'js/lodash.min.js' %}"></script>

<script>
    get = function(obj, key) {
	return key.split(".").reduce(function(o, x) {
	    return (typeof o == "undefined" || o === null) ? o : o[x];
	}, obj);
    }

  Vue.component('v-select', VueSelect.VueSelect);

  // Register a global custom directive called v-focus
  Vue.directive('focus', {
  // When the bound element is inserted into the DOM...
  inserted: function (el) {
  // Focus the element
  el.focus()
    
  }
  
  })

  var service_status_app = new Vue({
      el: '#service-status-app',
      data: {
          message: null,
	  initiald: "{{ first_of_month }}",
	  finald: "{{ last_of_month }}",
	  snapshots: {},
	  agentOptions: [{value: null, label: "Todos"},{% for agent in agents %}{value: {{ agent.pk }}, label: "{{ agent }}"},{% endfor %}],
	  selectedAgent: {value: null, label: "Todos"},
      },
      watch: {
	  initiald: function(newInitialD) {
	      if (newInitialD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  finald: function(newFinalD) {
	      if (newFinalD) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  },
	  selectedAgent: function(newAgent) {
	      if (newAgent) {
		  this.message = 'Refrescando datos...';
	      }
	      this.refreshData();
	  }
      },
      mounted: function () {
	  this.refreshData();
      },
      methods: {
	  refreshData: _.debounce(
	      function() {
		  this.$http.get('/customers/call-table-ajax/'+'?'+'initiald='+this.initiald+'&finald='+this.finald+'&agent='+get(this.selectedAgent, 'value')).then(response => {
		      var unordered = response.body.snapshot_data;
		      var ordered = {};
		      Object.keys(unordered).sort().forEach(function(key) {
			  ordered[key] = unordered[key];
		      });
		      this.snapshots = ordered;
		      this.message = null;
		  });
	      },
	      300
	  )
      }
  })

</script>

{% endblock %}
